// Web Cartoon Maker character include file
// You should include this file if you want to use the character
// The character is based on public domain images from openclipart.org

class Dog : public IFourLeggedCharacter
{
	public:

		// additional parts
		Part Tail;
		Part RightEar;
		Part LeftEar;

		// default constructor to register character, parts and decals
		Dog () : IFourLeggedCharacter ()
		{
			Tail.RegisterParent ( Body );
			RightEar.RegisterParent ( Head );
			LeftEar.RegisterParent ( Head );

			Register ( 300, 200, 153, 196 );

			RegisterPart ( RightRearLeg, "dog/RightRearLeg.svg", 54, 11, 203, 140 );
			RegisterPart ( RightFrontLeg, "dog/RightFrontLeg.svg", -47, 9, 102, 138 );
			RegisterPart ( Tail, "dog/Tail.svg", 72, -13, 221, 116 );
			RegisterPart ( Body, "dog/Body.svg", -4, -67, 149, 129 );
			RegisterPart ( LeftFrontLeg, "dog/LeftFrontLeg.svg", -31, 12, 118, 141 );
			RegisterPart ( LeftRearLeg, "dog/LeftRearLeg.svg", 51, 4, 200, 133 );
			RegisterPart ( Head, "dog/Head.svg", -79, -23, 70, 106 );
			RegisterPart ( RightEye, "dog/RightEye.svg", -18, -42, 52, 64 );
			RegisterPart ( LeftEye, "dog/LeftEye.svg", 2, -41, 72, 65 );
			RegisterPart ( Mouth, "dog/Mouth.svg", -10, 9, 60, 115 );
			RegisterPart ( RightEar, "dog/RightEar.svg", -27, -80, 43, 26 );
			RegisterPart ( LeftEar, "dog/LeftEar.svg", 13, -80, 83, 26 );

			Mouth.RegisterDecal ( "SPEAK_M", "dog/Mouth_Speak_M.svg" );
			Mouth.RegisterDecal ( "SPEAK_E", "dog/Mouth_Speak_E.svg" );
			Mouth.RegisterDecal ( "SPEAK_A", "dog/Mouth_Speak_A.svg" );
			Mouth.RegisterDecal ( "SPEAK_O", "dog/Mouth_Speak_O.svg" );
			Mouth.RegisterDecal ( "SPEAK_W", "dog/Mouth_Speak_W.svg" );

			LeftEye.RegisterDecal ( "WINK1", "dog/LeftEye_Wink1.svg" );
			LeftEye.RegisterDecal ( "WINK2", "dog/LeftEye_Wink2.svg" );

			RightEye.RegisterDecal ( "WINK1", "dog/RightEye_Wink1.svg" );
			RightEye.RegisterDecal ( "WINK2", "dog/RightEye_Wink2.svg" );

			RegisterSpeech ( "SAPI5", "Microsoft Mike", 0.6, 0.4, 1 );
		}
};