void AddWinking ( IHumanCharacter *pChar, double dWinkTime )
{
	double dThisTime = GetTime ();
	for ( double i=0; i<dThisTime; i+=dWinkTime )
	{
		SetTime ( i );
		pChar->Winks ();
	}
	
	SetTime ( dThisTime );
}

class IPolitCharacter : public IHumanCharacterSideView
{
	protected:
	public:

		IPolitCharacter () : IHumanCharacterSideView ()
		{
		}

		void SaysWithBalloon ( string sWhat )
		{
			const double dXShift = 40. * GetXScale () + 130;
			const double dYShift = 220. * GetYScale () + 150;
			const int iMaxChars = 18;
			
			double dTime = 0.16;
			int iLineLen = 0;
			int i;
			string sText;
			
			char *pRes = new char [ StrLen ( sWhat ) * 2 ];
			int iResLen = 0;
			
			for ( i=0; i < StrLen ( sWhat ); i++ )
			{
				if ( iLineLen > iMaxChars && ( sWhat [i] == ' ' || sWhat [i] == '\t' ) )
				{
					pRes [ iResLen ] = '\n';
					iLineLen = 0;
					iResLen++;
				}
			
				iLineLen ++;				
				pRes [ iResLen ] = sWhat [i];
				iResLen++;
				
				if ( sWhat [i] >= '0' && sWhat [i] < '9' ) dTime += 0.16;
				else dTime += 0.08;
	
				if ( iLineLen > iMaxChars && ( sWhat [i] == '?' || sWhat [i] == '.' || sWhat [i] == ',' || sWhat [i] == ';' || sWhat [i] == ':' ) )
				{
					pRes [ iResLen ] = '\n';
					iLineLen = 0;
					iResLen++;
				}
			}
			
			pRes [iResLen] = 0;

			Image Balloon;	
			Balloon.SetImage ( "polit/callout.svg" );
			
			Text BalloonText;
			BalloonText.SetFont ( "Arial" );
			BalloonText.SetText ( pRes );
			BalloonText.SetColor ( "000000" );
			BalloonText.SetSize (20);
			BalloonText.SetStyle ("B");
			
			if ( GetMirror () )
			{
				Balloon.SetPos ( GetX () + dXShift, GetY () - dYShift);
				BalloonText.SetPos ( GetX () + dXShift, GetY () - dYShift);
				Balloon.SetMirror ( true );
			}
			else
			{
				Balloon.SetPos ( GetX () - dXShift, GetY () - dYShift);
				BalloonText.SetPos ( GetX () - dXShift, GetY () - dYShift);
			}
			
			Balloon.SetVisible ( true );
			BalloonText.SetVisible ( true );
			Says ( sWhat );
			Sleep (dTime);
			Balloon.SetVisible ( false );
			BalloonText.SetVisible ( false );
			
		}
};

class Mironov : public IPolitCharacter
{
	public:

		// default constructor to register character, parts and decals
		Mironov () : IPolitCharacter ()
		{
			Register ( 350, 350, 183, 331 );

			RegisterPart ( RightLeg, "polit/mironov/RightLeg.svg", -16, 35, 166, 245 );
			RegisterPart ( RightArm, "polit/mironov/RightArm.svg", -27, -53, 155, 157 );
			RegisterPart ( LeftLeg, "polit/mironov/LeftLeg.svg", 31, 36, 213, 246 );
			RegisterPart ( Body, "polit/mironov/Body.svg", -1, -121, 182, 210 );
			RegisterPart ( LeftArm, "polit/mironov/LeftArm.svg", 50, -55, 232, 155 );
			RegisterPart ( Head, "polit/mironov/Head.svg", 1, -87, 183, 123 );
			RegisterPart ( Mouth, "polit/mironov/Mouth.svg", -10, -3, 173, 120 );
			RegisterPart ( RightEye, "polit/mironov/RightEye.svg", -27, -41, 156, 82 );
			RegisterPart ( LeftEye, "polit/mironov/LeftEye.svg", 12, -44, 195, 79 );

			Mouth.RegisterDecal ( "SPEAK_M", "polit/mironov/Mouth_Speak_M.svg" );
			Mouth.RegisterDecal ( "SPEAK_E", "polit/mironov/Mouth_Speak_E.svg" );
			Mouth.RegisterDecal ( "SPEAK_A", "polit/mironov/Mouth_Speak_A.svg" );
			Mouth.RegisterDecal ( "SPEAK_O", "polit/mironov/Mouth_Speak_O.svg" );
			Mouth.RegisterDecal ( "SPEAK_W", "polit/mironov/Mouth_Speak_W.svg" );

			LeftEye.RegisterDecal ( "WINK1", "polit/mironov/LeftEye_Wink1.svg" );
			LeftEye.RegisterDecal ( "WINK2", "polit/mironov/LeftEye_Wink2.svg" );

			RightEye.RegisterDecal ( "WINK1", "polit/mironov/RightEye_Wink1.svg" );
			RightEye.RegisterDecal ( "WINK2", "polit/mironov/RightEye_Wink2.svg" );
		}
};

class Surkov : public IPolitCharacter
{
	public:

		// additional parts
		Part Nose;

		// default constructor to register character, parts and decals
		Surkov () : IPolitCharacter ()
		{
			Register ( 350, 350, 183, 337 );

			RegisterPart ( RightLeg, "polit/surkov/RightLeg.svg", -12, 14, 167, 249 );
			RegisterPart ( RightArm, "polit/surkov/RightArm.svg", -24, -76, 155, 159 );
			RegisterPart ( LeftLeg, "polit/surkov/LeftLeg.svg", 35, 14, 214, 249 );
			RegisterPart ( Body, "polit/surkov/Body.svg", -4, -102, 179, 235 );
			RegisterPart ( LeftArm, "polit/surkov/LeftArm.svg", 54, -75, 233, 160 );
			RegisterPart ( Head, "polit/surkov/Head.svg", 5, -113, 184, 122 );
			RegisterPart ( Mouth, "polit/surkov/Mouth.svg", -6, 10, 178, 132 );
			RegisterPart ( Nose, "polit/surkov/Nose.svg", -11, -235, 172, 102 );			
			RegisterPart ( LeftEye, "polit/surkov/LeftEye.svg", 16, -30, 200, 92 );
			RegisterPart ( RightEye, "polit/surkov/RightEye.svg", -24, -31, 160, 91 );

			Mouth.RegisterDecal ( "SPEAK_M", "polit/surkov/Mouth_Speak_M.svg" );
			Mouth.RegisterDecal ( "SPEAK_E", "polit/surkov/Mouth_Speak_E.svg" );
			Mouth.RegisterDecal ( "SPEAK_A", "polit/surkov/Mouth_Speak_A.svg" );
			Mouth.RegisterDecal ( "SPEAK_O", "polit/surkov/Mouth_Speak_O.svg" );
			Mouth.RegisterDecal ( "SPEAK_W", "polit/surkov/Mouth_Speak_W.svg" );

			LeftEye.RegisterDecal ( "WINK1", "polit/surkov/LeftEye_Wink1.svg" );
			LeftEye.RegisterDecal ( "WINK2", "polit/surkov/LeftEye_Wink2.svg" );

			RightEye.RegisterDecal ( "WINK1", "polit/surkov/RightEye_Wink1.svg" );
			RightEye.RegisterDecal ( "WINK2", "polit/surkov/RightEye_Wink2.svg" );
		}
};

class Putin : public IPolitCharacter
{
	public:

		// default constructor to register character, parts and decals
		Putin () : IPolitCharacter ()
		{
			Register ( 350, 350, 184, 339 );

			RegisterPart ( RightLeg, "polit/putin/RightLeg.svg", -18, 20, 167, 251 );
			RegisterPart ( RightArm, "polit/putin/RightArm.svg", -30, -70, 155, 161 );
			RegisterPart ( LeftLeg, "polit/putin/LeftLeg.svg", 27, 21, 212, 252 );
			RegisterPart ( Body, "polit/putin/Body.svg", 1, -108, 185, 231 );
			RegisterPart ( LeftArm, "polit/putin/LeftArm.svg", 46, -69, 231, 162 );
			RegisterPart ( Head, "polit/putin/Head.svg", 1, -102, 186, 129 );
			RegisterPart ( LeftEye, "polit/putin/LeftEye.svg", -2, -36, 184, 93 );
			RegisterPart ( Mouth, "polit/putin/Mouth.svg", -21, 10, 165, 139 );
			RegisterPart ( RightEye, "polit/putin/RightEye.svg", -40, -43, 146, 86 );

			Mouth.RegisterDecal ( "SPEAK_M", "polit/putin/Mouth_Speak_M.svg" );
			Mouth.RegisterDecal ( "SPEAK_E", "polit/putin/Mouth_Speak_E.svg" );
			Mouth.RegisterDecal ( "SPEAK_A", "polit/putin/Mouth_Speak_A.svg" );
			Mouth.RegisterDecal ( "SPEAK_O", "polit/putin/Mouth_Speak_O.svg" );
			Mouth.RegisterDecal ( "SPEAK_W", "polit/putin/Mouth_Speak_W.svg" );

			LeftEye.RegisterDecal ( "WINK1", "polit/putin/LeftEye_Wink1.svg" );
			LeftEye.RegisterDecal ( "WINK2", "polit/putin/LeftEye_Wink2.svg" );

			RightEye.RegisterDecal ( "WINK1", "polit/putin/RightEye_Wink1.svg" );
			RightEye.RegisterDecal ( "WINK2", "polit/putin/RightEye_Wink2.svg" );
		}
};

class Medvedev : public IPolitCharacter
{
	public:

		// additional parts
		//Part Nose;

		// default constructor to register character, parts and decals
		Medvedev () : IPolitCharacter ()
		{
			Register ( 350, 350, 184, 333 );

			RegisterPart ( RightLeg, "polit/medvedev/RightLeg.svg", -19, 22, 166, 250 );
			RegisterPart ( RightArm, "polit/medvedev/RightArm.svg", -29, -69, 156, 159 );
			RegisterPart ( LeftLeg, "polit/medvedev/LeftLeg.svg", 29, 22, 214, 250 );
			RegisterPart ( Body, "polit/medvedev/Body.svg", 1, -105, 185, 228 );
			RegisterPart ( LeftArm, "polit/medvedev/LeftArm.svg", 48, -70, 233, 158 );
			RegisterPart ( Head, "polit/medvedev/Head.svg", 10, -109, 195, 119 );
			RegisterPart ( LeftEye, "polit/medvedev/LeftEye.svg", 0, -37, 195, 82 );
			RegisterPart ( RightEye, "polit/medvedev/RightEye.svg", -42, -35, 153, 84 );
			//RegisterPart ( Nose, "polit/medvedev/Nose.svg", 2, -231, 186, 102 );
			RegisterPart ( Mouth, "polit/medvedev/Mouth.svg", -23, 8, 172, 127 );

			Mouth.RegisterDecal ( "SPEAK_M", "polit/medvedev/Mouth_Speak_M.svg" );
			Mouth.RegisterDecal ( "SPEAK_E", "polit/medvedev/Mouth_Speak_E.svg" );
			Mouth.RegisterDecal ( "SPEAK_A", "polit/medvedev/Mouth_Speak_A.svg" );
			Mouth.RegisterDecal ( "SPEAK_O", "polit/medvedev/Mouth_Speak_O.svg" );
			Mouth.RegisterDecal ( "SPEAK_W", "polit/medvedev/Mouth_Speak_W.svg" );

			LeftEye.RegisterDecal ( "WINK1", "polit/medvedev/LeftEye_Wink1.svg" );
			LeftEye.RegisterDecal ( "WINK2", "polit/medvedev/LeftEye_Wink2.svg" );

			RightEye.RegisterDecal ( "WINK1", "polit/medvedev/RightEye_Wink1.svg" );
			RightEye.RegisterDecal ( "WINK2", "polit/medvedev/RightEye_Wink2.svg" );
		}
};
